
#include <time.h>
#include <stdio.h>

static int elapsed(struct timespec*,struct timespec*);

int outer = 50;
int inner = 10;
int threashold = 200;
int usecs;
int overruns;

double
work(void)
{
   volatile double d = 0.0;
   int i,j;
   for (i=0; i<outer; ++i) {
      for (j=0; j<inner; ++j) {
         d *= d;
      }
   }
}

int
main()
{
   struct timespec start;
   struct timespec stop;
   for (;;) {
      struct timespec t = {0,10000000};
      nanosleep(&t,0);
      clock_gettime(CLOCK_REALTIME,&start);
         work();
      clock_gettime(CLOCK_REALTIME,&stop);
      usecs = elapsed(&stop,&start);
      if (usecs > threashold) {
         printf ("Overrun %d\n",++overruns);
      }
   }
}

static
int
elapsed (struct timespec * stop, struct timespec * start)
{
   int sec = stop->tv_sec - stop->tv_sec;
   int nsec;
   if (stop->tv_nsec < start->tv_nsec) {
      sec--;
      nsec = 1000000000-(start->tv_nsec-stop->tv_nsec);
   } else {
      nsec = stop->tv_nsec-start->tv_nsec;
   }
   return sec * 1000000 + nsec/1000;
}
