#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <semaphore.h>
#include <time.h>
#include <errno.h>
#include <string.h>


/*
[root@RehHawk5 sem]# ./sem
initial semaphore value is 0
after sem_post semaphore value is 1
after sem_wait semaphore value is 0
status -1 Resource temporarily unavailable
current semaphore value is 0
successful lock a counting semaphore
current semaphore value is 0
*/

main()
{
	sem_t *sem;
	int pshared=2;	/* 2 process shared */
	int value=0;
	int sval,status;

	//create /var/tmp/posix_counting_semaphores/posix_sem0
	unlink("/dev/shm/sem.posix_sem0");
	sem = sem_open("/posix_sem0",O_CREAT|O_EXCL,0644,0);
	if (sem==(sem_t*)(-1))
	{
		printf("error %s\n",strerror(errno));
		exit(0);
	}
	sem_init(sem,pshared,value);

	sem_getvalue(sem,&sval); printf("initial semaphore value is %d\n",sval);

	sem_post(sem);
	sem_getvalue(sem,&sval); printf("after sem_post semaphore value is %d\n",sval);

	sem_wait(sem);
	sem_getvalue(sem,&sval); printf("after sem_wait semaphore value is %d\n",sval);

	status = sem_trywait(sem);
	if (status) 
		printf("status %d %s\n",status,strerror(errno));
	else
		printf("successful lock a counting semaphore\n");
	sem_getvalue(sem,&sval); printf("current semaphore value is %d\n",sval);
	
	sem_post(sem);
	status = sem_trywait(sem);
	if (status) 
		printf("status %d %s\n",status,strerror(errno));
	else
		printf("successful lock a counting semaphore\n");
	sem_getvalue(sem,&sval); printf("current semaphore value is %d\n",sval);

	sem_close(sem);
	sem_unlink("/posix_sem0");
}
